function E_rhs_mu = EGM_Step5a(mutil_c_n,mutil_c_a,P,P_KM,QQ,RR,AProb,par,mpar)
%EGM_Step5a determines the right-hand side of mu as defined in the paper 

% Copyright (c) 2018-05-27
% Christian Bayer, Ralph Luetticke, Lien Pham-Dao, and Volker Tjaden

%% Calculate returns


term1=(AProb.* mutil_c_a .*(QQ + RR))...
    +((1-AProb).* mutil_c_n .* RR);

E_rhs_mu=expect_mex_new(P,P_KM,par.beta*term1);

end

