%%
T=mpar.T(1,1)-1;
L=mpar.T(1,1)-mpar.T(2,1);
%%
D_sim_1 = (1-par.alpha)   *  MC_sim_1(2:end,:).* ((N_sim_1(2:end,:))./K_sim_1(2:end,:)).^(par.alpha)  - par.delta;
W_sim_1 =  par.alpha       * MC_sim_1.* (K_sim_1./N_sim_1).^(1-par.alpha);

R_sim_1 = q_sim_1(1:end-1,:).^-1.*(q_sim_1(2:end,:) +  D_sim_1);
Profits_sim_1=(1-MC_sim_1).*Y_sim_1;

M_sim_1  = mean(M_sim_1,2);
R_sim_1  = mean(R_sim_1,2);
PI_sim_1 = mean(PI_sim_1,2);
K_sim_1  = mean(K_sim_1,2);
q_sim_1  = mean(q_sim_1,2);
RB_sim_1 = mean(RB_sim_1,2);
D_sim_1 = mean(D_sim_1,2);
W_sim_1 = mean(W_sim_1,2);
MC_sim_1 = mean(MC_sim_1,2);
TaxRev_sim_1 = mean(TaxRev_sim_1,2);
Profits_sim_1 = mean(Profits_sim_1,2);
Y_sim_1 = mean(Y_sim_1,2);
C_sim_1 = mean(C_sim_1(1,:,:),3);
I_sim_1 = mean(I_sim_1,2);
G_sim_1 = mean(G_sim_1,2);
N_sim_1 = mean(N_sim_1,2);
H_sim_1 = mean(H_sim_1,2);

ss_sim_1 = (mean(ss_sim_1,2))+1;

Deficit_1=(M_sim_1(2:end) - M_sim_1(1:end-1)./PI_sim_1(1:end-1))./Y_sim_1(1:end-1);

lambdaIL_1=mean(lambdaIL_1,3);
lambdaLI_1=mean(lambdaLI_1,3);
lambdaC_1=mean(lambdaC_1,3);
lambdaX_1=mean(lambdaX_1,3);

%%
D_sim_0 =  (1-par.alpha)   *  MC_sim_0(2:end,:).* ((N_sim_0(2:end,:))./K_sim_0(2:end,:)).^(par.alpha)  - par.delta;
W_sim_0 =  par.alpha       * MC_sim_0.* (K_sim_0./(N_sim_0)).^(1-par.alpha);

R_sim_0 = q_sim_0(1:end-1,:).^-1.*(q_sim_0(2:end,:) +  D_sim_0);
Profits_sim_0=(1-MC_sim_0).*Y_sim_0;

M_sim_0  = mean(M_sim_0,2);
R_sim_0  = mean(R_sim_0,2);
PI_sim_0 = mean(PI_sim_0,2);
K_sim_0  = mean(K_sim_0,2);
q_sim_0  = mean(q_sim_0,2);
RB_sim_0 = mean(RB_sim_0,2);
D_sim_0 = mean(D_sim_0,2);
W_sim_0 = mean(W_sim_0,2);
MC_sim_0 = mean(MC_sim_0,2);
TaxRev_sim_0 = mean(TaxRev_sim_0,2);
Profits_sim_0 = mean(Profits_sim_0,2);
Y_sim_0 = mean(Y_sim_0,2);
C_sim_0 = mean(C_sim_0(1,:,:),3);
I_sim_0 = mean(I_sim_0,2);
G_sim_0 = mean(G_sim_0,2);
N_sim_0 = mean(N_sim_0,2);
H_sim_0 = mean(H_sim_0,2);

ss_sim_0 = (mean(ss_sim_0,2))+1;

Deficit_0=(M_sim_0(2:end) - M_sim_0(1:end-1)./PI_sim_0(1:end-1))./Y_sim_0(1:end-1);


lambdaIL_0=mean(lambdaIL_0,3);
lambdaLI_0=mean(lambdaLI_0,3);
lambdaC_0=mean(lambdaC_0,3);
lambdaX_0=mean(lambdaX_0,3);

%% IRF data KS
IRF_Y_KS=100*(Y_sim_1(mpar.T(2,1):T)./Y_sim_0(mpar.T(2,1):T)-1);
IRF_S_KS=100*(ss_sim_1(mpar.T(2,1):T)./ss_sim_0(mpar.T(2,1):T)-1);
IRF_C_KS=100*((C_sim_1(mpar.T(2,1):T)./C_sim_0(mpar.T(2,1):T))-1);
IRF_I_KS=100*(I_sim_1(mpar.T(2,1):T)./I_sim_0(mpar.T(2,1):T)-1);
IRF_G_KS=100*(G_sim_1(mpar.T(2,1):T)./G_sim_0(mpar.T(2,1):T)-1);
IRF_K_KS=100*(K_sim_1(mpar.T(2,1):T)./K_sim_0(mpar.T(2,1):T)-1);
IRF_W_KS=100*(W_sim_1(mpar.T(2,1):T)./W_sim_0(mpar.T(2,1):T)-1);
IRF_N_KS=100*(N_sim_1(mpar.T(2,1):T)./N_sim_0(mpar.T(2,1):T)-1);
IRF_M_KS=100*(M_sim_1(mpar.T(2,1):T)./M_sim_0(mpar.T(2,1):T)-1);
IRF_H_KS=100*(H_sim_1(mpar.T(2,1):T)./H_sim_0(mpar.T(2,1):T)-1);

IRF_PI_KS=100*100*(PI_sim_1(mpar.T(2,1):T)-PI_sim_0(mpar.T(2,1):T));
IRF_RBREAL_KS=100*100*(RB_sim_1(mpar.T(2,1):T-1)./PI_sim_1(mpar.T(2,1)+1:T+1-1)...
    -RB_sim_0(mpar.T(2,1):T-1)./PI_sim_0(mpar.T(2,1)+1:T+1-1));
IRF_RB_KS=100*100*(RB_sim_1(mpar.T(2,1):T)-RB_sim_0(mpar.T(2,1):T));
IRF_Q_KS=100*100*(q_sim_1(mpar.T(2,1):T)-q_sim_0(mpar.T(2,1):T));
IRF_D_KS=100*100*(D_sim_1(mpar.T(2,1)-1:T-1)-D_sim_0(mpar.T(2,1)-1:T-1));
IRF_LIP_KS=100*100*((R_sim_1(mpar.T(2,1):T-1) - RB_sim_1(mpar.T(2,1):T-1)./PI_sim_1(mpar.T(2,1)+1:T)) ...
    -(R_sim_0(mpar.T(2,1):T-1) - RB_sim_0(mpar.T(2,1):T-1)./PI_sim_0(mpar.T(2,1)+1:T)));
IRF_Deficit_KS= 100*(Deficit_1(mpar.T(2,1):T)-Deficit_0(mpar.T(2,1):T));

save KS_IRF_data par IRF_H_KS IRF_Deficit_KS IRF_Y_KS IRF_C_KS IRF_I_KS IRF_G_KS IRF_K_KS IRF_W_KS IRF_N_KS IRF_M_KS IRF_PI_KS IRF_RBREAL_KS IRF_RB_KS IRF_Q_KS IRF_D_KS IRF_LIP_KS IRF_S_KS

%% IRF 1: Output and its Components
scrsz = get(0,'ScreenSize');
figurename=['IRF_Y_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_Y_KS,'blue','LineWidth',3)
xlim([0 L])
ylabel('Percent','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_C_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_C_KS,'blue','LineWidth',3)   % Household consumption
hold on
xlim([0 L])
ylabel('Percent','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_I_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_I_KS,'blue','LineWidth',3)
xlim([0 L])
ylabel('Percent','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_G_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_G_KS,'blue','LineWidth',3)
xlim([0 L])
ylabel('Percent','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])

%% IRF 2: States
figurename=['IRF_K_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_K_KS,'blue','LineWidth',3)
xlim([0 L])
ylabel('Percentage','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])


figurename=['IRF_MC_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(100*(MC_sim_1(mpar.T(2,1):T)-MC_sim_0(mpar.T(2,1):T)),'blue','LineWidth',3)
xlim([0 L])
ylabel('Percentage Points','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_W_N_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_W_KS,'blue','LineWidth',3)
xlim([0 L])
hold on
plot(IRF_N_KS,'--b','LineWidth',3)
legend('Wage','Hours','Location','SouthEast')
set(legend,'FontSize',35,'interpreter','latex');
ylabel('Percentage','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])


figurename=['IRF_M_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_M_KS,'blue','LineWidth',3)
xlim([0 L])
ylabel('Percentage','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])


%% IRF 3:  Prices
figurename=['IRF_PI_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_PI_KS,'LineWidth',3)
xlim([0 L])
ylabel('Basis Points','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])


figurename=['IRF_nom_realRB_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_RBREAL_KS,'LineWidth',3)
hold on
plot(IRF_RB_KS,'LineWidth',3)
legend('real','nominal','Location','SouthEast')
set(legend,'FontSize',35,'interpreter','latex');
xlim([0 40])
ylabel('Basis Points','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_LiquPR_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_LIP_KS,'LineWidth',3)
xlim([0 40])
ylabel('Basis Points','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_q_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_Q_KS,'LineWidth',3)
xlim([0 40])
ylabel('Basis Points','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])

figurename=['IRF_D_' SS_name '_thetaPI_' num2str(100*par.theta_pi)  '_gamma_pi_' num2str(100*par.gamma_pi)];
figure('Name',figurename,'NumberTitle','off','Position',[1 1 700 700])
plot(IRF_D_KS,'LineWidth',3)
xlim([0 40])
ylabel('Basis Points','FontSize',30,'interpreter','latex')
xlabel('Quarter','FontSize',30,'interpreter','latex')
hold on
plot(zeros(1,T),'--black')
set(gca, 'FontName', 'times new roman','FontSize',20);
set(gca,'Position',[0.175 0.10 0.78 0.85])
printpdf(gcf,['latex/' figurename])

