function [ N,W_fc,Profits_fc,WW,RBRB,R_fc,Y ] = factor_returns(meshes,K,par,mpar)
%factor_returns
  
%%  GHH Preferences    
  
    mc   =  par.mu - (par.beta * log(par.PI) - log(par.PI))/par.kappa;
    N    =  (par.tau.*par.alpha.*K^(1-par.alpha).*mc).^(1/(1-par.alpha+par.gamma));   
    W_fc =  par.alpha .*mc.* (K./N).^(1-par.alpha);        
    R_fc = (1-par.alpha) .*mc.* (N./K).^(par.alpha)- par.delta;
    Y = (N).^(par.alpha).*K.^(1-par.alpha);
    Profits_fc = (1-mc)*Y - Y.*(1/(1-par.mu))./par.kappa./2 .*log(par.PI).^2;
 
    %%
    NW=par.gamma/(1+par.gamma).*(N/par.H).*W_fc;
    WW=NW*ones(mpar.nm,mpar.ns*mpar.nh); %Wages
    WW(:,end)=Profits_fc*par.profitshare;
    RBRB = (1+R_fc);

end

