function [ m_a_new,k_a_new ] = KS_EGM_Step4( res_list,mon_list,cap_list,meshes,R,Q,RB,mpar,grid )
%KS_EGM_Step4 returns current period money and capital policies in the case
% of adjustment.
% Copyright (c) 2018-05-27
% Christian Bayer, Ralph Luetticke, Lien Pham-Dao, and Volker Tjaden

m_a_new=zeros([mpar.nm_sim*mpar.nk_sim, mpar.nh]);
k_a_new=zeros([mpar.nm_sim*mpar.nk_sim, mpar.nh]);

Resource_grid=reshape(meshes.k*(Q+R)+RB*meshes.m,[mpar.nm_sim*mpar.nk_sim, mpar.nh]);

for j=1:mpar.nh
    log_index=Resource_grid(:,j)<res_list{j}(1);
     [m_a_new(:,j),k_a_new(:,j)] = ...
        myinter1m_mex(res_list{j},Resource_grid(:,j),mon_list{j},cap_list{j}); 
    m_a_new(log_index,j)=grid.m_sim(1);
    k_a_new(log_index,j)=0;
end
k_a_new=reshape(k_a_new,[mpar.nm_sim ,mpar.nk_sim, mpar.nh]);
m_a_new=reshape(m_a_new,[mpar.nm_sim ,mpar.nk_sim, mpar.nh]);
end


