% Steady state statistics    
    %%    
    
    clear targets
    targets.ShareBorrower=sum((grid.m<0).*sum(joint_distr,2)');
    Kaux    = grid.m*(sum(joint_distr,2));
    grid.B  = par.BtoK/(1+par.BtoK)*Kaux;

    targets.K=grid.m*(sum(joint_distr,2))-grid.B;
    targets.B=grid.B; 
    targets.KY=targets.K/Output;
    targets.BK=grid.B/targets.K;
    targets.Y=Output;
    BCaux_M=sum(sum(joint_distr,2),3);
    targets.m_bc=BCaux_M(1,:);
    targets.m_0=BCaux_M(grid.m==0);
    par.RB = 1+R_fc;
    
    tax =(1-par.tau).*W_fc.*N +(1-par.tau).*Profits_fc;
    par.gamma1=targets.B*(1-par.RB)+tax(1);
    par.W=W_fc(1);
    par.PROFITS=Profits_fc(1);
    par.N=N;
    par.R=R_fc;
    targets.GtoY=par.gamma1/Output;
    targets.T=tax;
    
    